$(document).ready(function () { 

 if (JSON_PARAMETER['signedFileId']){
    $.ajax({
        //url: "https://murachi.cenditel.gob.ve/Murachi/0.1/archivos/"+signedFileId,
        url: "https://192.168.12.154:8443/Murachi/0.1/archivos/"+JSON_PARAMETER['signedFileId'],
        type: "get",
        dataType: "json",        
        headers: {"Authorization":"Basic YWRtaW46YWRtaW4="},
        success: function(response) {
            INFO_DATATABLE_QR = SerealizeMyJson(response);
			var linkToDownload = "<a class='learn-more-btn' href=\"https://192.168.12.154:8443/Murachi/0.1/archivos/descargas/" + JSON_PARAMETER['signedFileId'] +"\"><h6>Descargar archivo firmado</h6></a>";
			document.getElementById("Descarga").innerHTML = linkToDownload;  			
            var table = $('#myJson').DataTable({
                  //retrieve: true,
                  //paging: false,
                  //searching: false,                            
                   language: {
                      "lengthMenu": "Mostrar _MENU_ registros",
                      "zeroRecords": "No hay resultados - Disculpe",
                      "info": "Mostrando pagina _PAGE_ de _PAGES_",
                      "search": "Buscar:", 
                      "infoEmpty": "No records available",
                      "infoFiltered": "(filtered from _MAX_ total records)"
                   },
                   columnDefs: [
                      {"className": "dt-center", "targets": "_all"}
                   ],                       
                   order: [[ 1, 'desc' ]],       
                   data: response.signatures,
                   columns: [
                      {title: "Nombre del firmante", data: "nameOfTheSigner"  },
                      {title: "Fecha en que se realiza la firma", data: "signedOn"},         
                      {title: "Chequea la integridad de la firma", data: "integrityCheck"},
                      {title: "El certificado todavía está válido", data: "signerCertificateStillValid"},
                      {title: "Fecha de inicio de validez del certificado", data: "signerCertificateValidFrom"},                        
                      {title: "Fecha de fin de validez del certificado", data: "signerCertificateValidTo"},
                      {title: "El certificado es válido en el momento de la firma", data: "signerCertificateValidAtTimeOfSigning"},                
                      {title: "Tipo de firma de archivo PDF", data: "signatureType"},
                      {title: "Estampilla de tiempo", data: "timeStamp"},
                      {title: " Razón de la firma", data: "reason"},
                      {title: "Ubicación donde se realiza la firma", data: "location"},
                      {title: "Nombre alternativo del firmante", data: "alternativeNameOfTheSigner"},
                      {title: "La firma abarca todo el documento PDF", data: "signatureCoversWholeDocument"},
                      {title: "Tipo de subfiltro: /adbe.pkcs7.sha1, /adbe.pkcs7.detached", data: "filterSubtype"},
                      {title: "Sujeto firmante", data: "signerCertificateSubject"},
                      {title: "Algoritmo de cifrado", data: "encryptionAlgorithm"},
                      {title: "Servicio de estampillado de tiempo", data: "timeStampService"},
                      {title: "Algoritmo hash (reseña)", data: "digestAlgorithm"},
                      {title: "Certificado verificado contra el repositorio de certificados confiables", data: "certificatesVerifiedAgainstTheKeyStore"},
                      {title: "Número de revisión del documento PDF", data: "documentRevision"},
                      {title: "Número total de revisiones del documento PDF", data: "totalDocumentRevisions"},
                      {title: "Información de contacto del firmante", data: "contactInfo", style:"width: 2px;"},
                      {title: "Estampilla de tiempo verificada", data: "timeStampVerified"},
                      {title: "Emisor del certificado firmante", data: "signerCertificateIssuer"},
                      {title:"Información", data: function(event){
                                                      return '<button id="informacion" type="input" class="btn btn-success btn-sm" data-toggle="modal" data-target="#myModal" onclick="javascript:DialogQR('+event.documentRevision+')">Info(<font color="red">'+event.documentRevision+'</font>)</button>';
                                                 } 
                      }
                   ],                           
                  dom: 'Bfrtip',
                  columnDefs: [
                      {
                          "targets": [ 2,3,4,5,6,8,9,11,12,13,14,15,16,17,18,19,20,21,22,23 ],
                          "visible": false,
                          //"searchable": false
                      },
                      
                   ],                           
                   buttons: [
                        {
                            extend:    'pageLength',
                            text:      'Mostrar Filas', 
                            titleAttr: 'Mostrar Filas',
                        },
                        {
                            extend:    'print',
                            text:      'Imprimir',
                            title:     'Contenido de la Firma',
                            message:   'Datos de la Firma',
                            titleAttr: 'Imprimir',
                            exportOptions: {
                              columns: [ 0,1,2,3,4,5,6,8,9,11,12,13,14,15,16,17,18,19,20,21,22,23]
                            } 
                        },
                        {
                            extend:    'excelHtml5',
                            text:      'XLXS',
                            title:     'Contenido de la Firma',
                            titleAttr: 'Excel',
                            message: 'Datos de la Firma',
                            exportOptions: {
                              columns: [ 0,1,2,3,4,5,6,8,9,11,12,13,14,15,16,17,18,19,20,21,22,23]
                            }
                        },
                        {
                            extend:    'csvHtml5',
                            text:      'CSV',
                            title:     'Contenido de la Firma',
                            titleAttr: 'CSV',
                            exportOptions: {
                              columns: [ 0,1,2,3,4,5,6,8,9,11,12,13,14,15,16,17,18,19,20,21,22,23]
                            }
                        },
                        {
                            extend:    'pdfHtml5',
                            text:      'PDF',
                            titleAttr: 'PDF',
                            title:     'Contenido de la Firma',                    
                            download: 'open',
                            customize: function (doc){
                               doc.defaultStyle.fontSize = 3;
                               doc.styles.tableHeader.fontSize = 4;
                               doc.styles.tableHeader.fillColor = "#0085a1";
                            },
                            //orientation: 'landscape',
                            pageSize: 'A3',
                            exportOptions: {
                              columns: [ 0,1,2,3,4,5,6,8,9,11,12,13,14,15,16,17,18,19,20,21,22,23]
                            
                            }
                        }                
                  ]           
              });        
      
        },
        error: function(jqXHR, textStatus, errorThrown){
            alert(textStatus+", "+ errorThrown+" el documento PDF para mostrar la info de la sign");     
			document.getElementById("404").innerHTML = "<h1>404!</h1> <br><h3>PAGE NO FOUND</h3>  ";
        }
    });

    function SerealizeMyJson(data){
      for (var i = 0; i < data.signatures.length; i++) {
          data.signatures[i].integrityCheck = True_False(data.signatures[i].integrityCheck);
          data.signatures[i].signerCertificateStillValid = True_False(data.signatures[i].signerCertificateStillValid);
          data.signatures[i].signerCertificateValidAtTimeOfSigning = True_False(data.signatures[i].signerCertificateValidAtTimeOfSigning);
          data.signatures[i].signatureCoversWholeDocument = True_False(data.signatures[i].signatureCoversWholeDocument);
          data.signatures[i].certificatesVerifiedAgainstTheKeyStore = True_False(data.signatures[i].certificatesVerifiedAgainstTheKeyStore);         
      }
      return data;
    }

    function True_False(data){

        if (data == "true" ){
          return "Verdadero";
        }
        if (data ==  "false"){
          return "Falso";
        }
    }
 }
 else {
	document.getElementById("404").innerHTML = "<h1>Bienvenidos</h1> <br><h3>No se encontro información de la QR! </h3>  ";
 }
});  



function DialogQR(id){
   document.getElementById("Dialogo_QR").innerHTML = '\
    <style>\
     .modal .modal-dialog { width: 80%; height: 80%, };\
    </style>\
       <div id="myModal" class="modal fade" role="dialog">\
       <div class="modal-dialog">\
         <div class="modal-content">\
           <div id = "title" class="modal-header">\
             <!--<button type="button" class="close" data-dismiss="modal">&times;</button>-->\
             <h4 class="modal-title text-primary"><center>Información de la Firma('+id+')</center></h4>\
           </div>\
           <div id = "body" class="modal-body">\
             <br>\
             <div id="Dialogo-table-QR"></div>\
            </div>\
            <div class="modal-footer">\
              <button type="button" id="informacion" data-dismiss="modal">Close</button>\
            </div>\
          </div>\
        </div>\
    </div>';

    InfoContentQR(id);
}


function InfoContentQR(id){
  
  for (var i = 0; i < INFO_DATATABLE_QR.signatures.length; i++) {
    if (parseInt(INFO_DATATABLE_QR.signatures[i]['documentRevision']) == parseInt(id)){

            var html1 = "";  

            html1 += '<font style="font-size: 14pt">';
            html1 += '<table  class="table table-hover" width="100%" id="data" >';
            html1 += '<tr>';
            html1 += '<td style="text-align: left" width="700"><b>Nombre del firmante:</b> </td>';
            html1 += '<td style="text-align: left" width="500"><span> '+INFO_DATATABLE_QR.signatures[i]['nameOfTheSigner']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Fecha en que se realiza la firma:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['signedOn']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Chequea la integridad de la firma:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['integrityCheck']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>El certificado todavía está válido:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['signerCertificateStillValid']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Fecha de fin de validez del certificado:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['signerCertificateValidFrom']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Fecha de fin de validez del certificado:</b> </td>';
            html1 += '<td style="text-align: left"><span>' +INFO_DATATABLE_QR.signatures[i]['signerCertificateValidTo']+'</span></td>';
            html1 += '</tr>'; 
            html1 += '<tr>';
            html1 += '<td style="text-align: left" ><b>El certificado es válido en el momento de la firma:</b> </td>';
            html1 += '<td style="text-align: left" ><span> '+INFO_DATATABLE_QR.signatures[i]['signerCertificateValidAtTimeOfSigning']+'</span></td>';
            html1 += '</tr>'; 
            html1 += '<tr>';
            html1 += '<td style="text-align: left" ><b>Tipo de firma de archivo PDF:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['signatureType']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Estampilla de tiempo:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['timeStamp']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Razón de la firma:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['reason']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Ubicación donde se realiza la firma:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['location']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Nombre alternativo del firmante:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['alternativeNameOfTheSigner']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>La firma abarca todo el documento PDF:</b> </td>';
            html1 += '<td style="text-align: left"><span>' +INFO_DATATABLE_QR.signatures[i]['signatureCoversWholeDocument']+'</span></td>';
            html1 += '</tr>'; 
            html1 += '<tr>';
            html1 += '<td style="text-align: left" ><b>Tipo de subfiltro: /adbe.pkcs7.sha1, /adbe.pkcs7.detached:</b> </td>';
            html1 += '<td style="text-align: left" ><span> '+INFO_DATATABLE_QR.signatures[i]['filterSubtype']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Sujeto firmante:</b> </td>';
            html1 += '<td style="text-align: left"><span><font style="font-size: 8pt">' +INFO_DATATABLE_QR.signatures[i]['signerCertificateSubject']+'</font></span></td>';
            html1 += '</tr>';
            html1 += '<td style="text-align: left" ><b>Algoritmo de cifrado:</b> </td>';
            html1 += '<td style="text-align: left" ><span> '+INFO_DATATABLE_QR.signatures[i]['encryptionAlgorithm']+'</span></td>';
            html1 += '</tr>'; 
            html1 += '<tr>';
            html1 += '<td style="text-align: left" ><b>Servicio de estampillado de tiempo:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['timeStampService']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Algoritmo hash (reseña):</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['digestAlgorithm']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Certificado verificado contra el repositorio de certificados confiables:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['certificatesVerifiedAgainstTheKeyStore']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Número de revisión del documento PDF:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['documentRevision']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Número total de revisiones del documento PDF:</b> </td>';
            html1 += '<td style="text-align: left"><span> '+INFO_DATATABLE_QR.signatures[i]['totalDocumentRevisions']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Información de contacto del firmante:</b> </td>';
            html1 += '<td style="text-align: left"><span>' +INFO_DATATABLE_QR.signatures[i]['contactInfo']+'</span></td>';
            html1 += '</tr>'; 
            html1 += '<tr>';
            html1 += '<td style="text-align: left" ><b>Estampilla de tiempo verificada:</b> </td>';
            html1 += '<td style="text-align: left" ><span> '+INFO_DATATABLE_QR.signatures[i]['timeStampVerified']+'</span></td>';
            html1 += '</tr>';
            html1 += '<tr>';
            html1 += '<td style="text-align: left"><b>Emisor del certificado firmante:</b> </td>';
            html1 += '<td style="text-align: left"><span><font style="font-size: 8pt">' +INFO_DATATABLE_QR.signatures[i]['signerCertificateIssuer']+'</font></span></td>';
            html1 += '</tr>';;
            html1 += '</table>';
            html1 += '</font>';

            $('div#Dialogo-table-QR').append(html1); 
    }
  }
}

